## librtr 0.6.3

=== CMakeLists.txt ===
project(rtrlib C)

set(PROJECT_DESCRIPTION "Lightweight C library that implements the RPKI/RTR protocol and prefix origin validation.")

cmake_minimum_required(VERSION 2.6)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=gnu99 -fstack-protector-all")
if(CMAKE_BUILD_TYPE STREQUAL Debug)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -Wformat-security -Wmissing-prototypes -Wmissing-declarations -Wdeclaration-after-statement -Winit-self -Waggregate-return -Wmissing-format-attribute -Wundef -Wbad-function-cast -Wwrite-strings -Wformat=2")
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    if(GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wfree-nonheap-object")
    endif()

    set(DOCS_EXCLUDE_PATTERN "")
else()
    set(DOCS_EXCLUDE_PATTERN "*_private.h")
endif(CMAKE_BUILD_TYPE STREQUAL Debug)

include_directories(.)

find_package(codecov)

find_package(Threads REQUIRED)
if(NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    find_library(RT_LIB rt)
endif(NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")

include(GNUInstallDirs) # for man page install path

set(RTRLIB_SRC rtrlib/rtr_mgr.c rtrlib/lib/utils.c rtrlib/lib/alloc_utils.c rtrlib/lib/convert_byte_order.c
    rtrlib/lib/ip.c rtrlib/lib/ipv4.c rtrlib/lib/ipv6.c rtrlib/lib/log.c
    rtrlib/pfx/trie/trie.c rtrlib/pfx/trie/trie-pfx.c rtrlib/transport/transport.c
    rtrlib/transport/tcp/tcp_transport.c rtrlib/rtr/rtr.c rtrlib/rtr/packets.c
    rtrlib/spki/hashtable/ht-spkitable.c rtrlib/spki/hashtable/tommyds-1.8/tommy.c)
set(RTRLIB_LINK ${RT_LIB} ${CMAKE_THREAD_LIBS_INIT})

find_package(LibSSH 0.5.0 QUIET)
if(LIBSSH_FOUND AND NOT NOSSH)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D LIBSSH_VERSION_MAJOR=${LibSSH_VERSION_MAJOR} -D LIBSSH_VERSION_MINOR=${LibSSH_VERSION_MINOR}")
    set(RTRLIB_HAVE_LIBSSH 1)
    include_directories(${LIBSSH_INCLUDE_DIRS})
    set(RTRLIB_SRC ${RTRLIB_SRC} rtrlib/transport/ssh/ssh_transport.c)
    set(RTRLIB_LINK ${RTRLIB_LINK} ${LIBSSH_LIBRARIES})
    message(STATUS "libssh found, building librtr with SSH ${LibSSH_VERSION} support")
else()
    message(WARNING "libssh >=0.5.0 not found, building librtr without SSH support")
endif(LIBSSH_FOUND AND NOT NOSSH)

#doxygen target
find_package(Doxygen)
if(DOXYGEN_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doxygen/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/doxygen/Doxyfile @ONLY)

    add_custom_target(doc ALL ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxygen/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating doxygen API documentation" VERBATIM)
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs DESTINATION share/doc/rtrlib)
endif(DOXYGEN_FOUND)

add_library(rtrlib SHARED ${RTRLIB_SRC})
add_coverage(rtrlib)
target_link_libraries(rtrlib ${RTRLIB_LINK})
set_target_properties(rtrlib PROPERTIES C_VISIBILITY_PRESET hidden)

add_library(rtrlib_static STATIC ${RTRLIB_SRC})
add_coverage(rtrlib_static)
target_link_libraries(rtrlib_static ${RTRLIB_LINK})

ADD_SUBDIRECTORY(tools)

ADD_SUBDIRECTORY(doxygen/examples)

include(AddTest)
ADD_SUBDIRECTORY(tests)
ENABLE_TESTING()
ADD_TEST(test_pfx tests/test_pfx)
ADD_TEST(test_trie tests/test_trie)
#ADD_TEST(test_pfx_locks tests/test_pfx_locks)

ADD_TEST(test_ht_spkitable tests/test_ht_spkitable)
ADD_TEST(test_ht_spkitable_locks tests/test_ht_spkitable_locks)

ADD_TEST(test_live_validation tests/test_live_validation)

ADD_TEST(test_ipaddr tests/test_ipaddr)

ADD_TEST(test_getbits tests/test_getbits)

ADD_TEST(test_dynamic_groups tests/test_dynamic_groups)

#install lib
set (RTRLIB_VERSION_MAJOR 0)
set (RTRLIB_VERSION_MINOR 6)
set (RTRLIB_VERSION_PATCH 3)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h.cmake ${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h)
set(LIBRARY_VERSION ${RTRLIB_VERSION_MAJOR}.${RTRLIB_VERSION_MINOR}.${RTRLIB_VERSION_PATCH})
set(LIBRARY_SOVERSION ${RTRLIB_VERSION_MAJOR})
set_target_properties(rtrlib PROPERTIES SOVERSION ${LIBRARY_SOVERSION} VERSION ${LIBRARY_VERSION} OUTPUT_NAME rtr)
install(TARGETS rtrlib LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/)


# Get lists of all headers
file(GLOB_RECURSE RTRLIB_HEADERS RELATIVE "${PROJECT_SOURCE_DIR}/rtrlib" "rtrlib/*.h")
# Create list of all public headers
foreach(ITEM ${RTRLIB_HEADERS})
    if(NOT ${ITEM} MATCHES ".*_private\\.h" AND NOT ${ITEM} MATCHES ".*tommy.*")
        list(APPEND RTRLIB_PUBLIC_HEADERS ${ITEM})
    endif()
endforeach()

#install includes
foreach(ITEM ${RTRLIB_PUBLIC_HEADERS})
    get_filename_component(HEADER_DIRECTORY "${ITEM}" PATH)
    install(FILES "rtrlib/${ITEM}"
        DESTINATION "include/rtrlib/${HEADER_DIRECTORY}")
endforeach()

#pkgconfig file
if(LIBSSH_FOUND)
    set (PKG_CONFIG_REQUIRES "libssh >= 0.5.0")
endif(LIBSSH_FOUND)

# '#include <rtrlib/rtrlib.h>' includes the "rtrlib/"
set (PKG_CONFIG_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
set (PKG_CONFIG_INCLUDEDIR "\${prefix}/include")
set (PKG_CONFIG_LIBS       "-L\${libdir} -lrtr")
set (PKG_CONFIG_CFLAGS     "-I\${includedir}")

configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/pkg-config.pc.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
)
install (
    FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)
#add uninstall target
configure_file(
    "cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

coverage_evaluate()

=== tools/CMakeLists.txt ===
add_executable(rtrclient rtrclient.c)
target_link_libraries(rtrclient rtrlib)
install(TARGETS rtrclient DESTINATION bin)
install(FILES "rtrclient.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")

add_executable(rpki-rov rpki-rov.c)
target_link_libraries(rpki-rov rtrlib)
install(TARGETS rpki-rov DESTINATION bin)
install(FILES "rpki-rov.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")

=== doxygen/examples/CMakeLists.txt ===
if(CMAKE_BUILD_TYPE STREQUAL Debug)
    if(LIBSSH_FOUND)
        add_executable(rtr_mgr rtr_mgr.c)
        target_link_libraries(rtr_mgr rtrlib)
        add_executable(ssh_tr ssh_tr.c)
        target_link_libraries(ssh_tr rtrlib_static)
    endif(LIBSSH_FOUND)
endif(CMAKE_BUILD_TYPE STREQUAL Debug)

=== rtrlib/spki/hashtable/tommyds-1.8/Makefile ===
#############################################################################
# Tommy Makefile

VERSION=1.8
CFLAGS=-m32 -O3 -march=pentium4 -mtune=generic -Wall -Wextra -g
# -std=c++11 required by Google btree
CCFLAGS=$(CFLAGS) -fpermissive -std=c++11
CC=gcc
CXX=g++
UNAME=$(shell uname)

# Linux
ifeq ($(UNAME),Linux)
LIB=-lrt benchmark/lib/judy/libJudyL.a benchmark/lib/judy/libJudyMalloc.a
EXE=
O=.o
endif

# Darwin
ifeq ($(UNAME),Darwin)
LIB=
EXE=
O=.o
endif

# Windows
ifeq ($(UNAME),)
LIB=benchmark/lib/judy/src/judy.lib
EXE=.exe
O=.obj
endif

CHECK = ./tommybench -N 1000000 -d tommy-hashlin
#CHECK = ./tommycheck

DEP = \
	tommyalloc.c \
	tommyalloc.h \
	tommyarray.c \
	tommyarray.h \
	tommyarrayof.c \
	tommyarrayof.h \
	tommyarrayblk.c \
	tommyarrayblk.h \
	tommyarrayblkof.c \
	tommyarrayblkof.h \
	tommy.c \
	tommy.h \
	tommyhash.c \
	tommyhashdyn.c \
	tommyhashdyn.h \
	tommyhash.h \
	tommyhashlin.c \
	tommyhashlin.h \
	tommyhashtbl.c \
	tommyhashtbl.h \
	tommylist.c \
	tommylist.h \
	tommytrie.c \
	tommytrie.h \
	tommytrieinp.c \
	tommytrieinp.h \
	tommytypes.h \
	tommychain.h

all: tommycheck$(EXE) tommybench$(EXE)

tommy$(O): $(DEP)
	$(CC) $(CFLAGS) -c tommy.c -o tommy$(O)
	$(CC) $(CFLAGS) -S -fverbose-asm tommy.c -o tommy.s
	objdump -S tommy$(O) > tommy.S

tommycheck$(EXE): check.c tommy$(O)
	$(CC) $(CFLAGS) check.c tommy.o -o tommycheck$(EXE) $(LIB)

tommybench$(EXE): benchmark.cc $(DEP)
	$(CXX) $(CCFLAGS) benchmark.cc -o tommybench$(EXE) $(LIB)

check: tommycheck$(EXE) tommybench$(EXE)
	./tommycheck$(EXE)
	./tommybench$(EXE) -N 100000
	echo Check completed with success!

valgrind:
	valgrind \
		--tool=memcheck \
		--track-origins=yes \
		--read-var-info=yes \
		-v $(CHECK) \
		2> valgrind.log
		tail valgrind.log

callgrind:
	valgrind \
		--tool=callgrind \
		--dump-instr=yes \
		--trace-jump=yes \
		-v $(CHECK) \
		2> callgrind.log
		tail callgrind.log

cachegrind:
	valgrind \
		--tool=cachegrind \
		-v $(CHECK) \
		2> cachegrind.log
		tail cachegrind.log

phony:

graph: phony
	cd benchmark && sh gr_all.sh

doc: phony tommy.doxygen tommy.css $(DEP)
	rm -rf doc
	mkdir doc
	cp -a benchmark/data/* doc/
	rm -f doc/*/*.lst
	rm -f doc/*/*.gnu
	doxygen tommy.doxygen
	rm -f doc/doxygen.png
	rm -f doc/tab_*.png

web: phony tommyweb.doxygen tommy.css $(DEP)
	rm -rf web
	mkdir web
	cp -a benchmark/data/* web/
	rm -f web/*/*.lst
	rm -f web/*/*.gnu
	doxygen tommyweb.doxygen
	rm -f web/doxygen.png
	rm -f web/tab_*.png

clean:
	rm -f *.log *.s *.S *.lst *.o
	rm -f *.ncb *.suo *.obj
	rm -rf Debug Release x64
	rm -f callgrind.out.*
	rm -f cachegrind.out.*

distclean: clean
	rm -f tommybench$(EXE) tommycheck$(EXE)

maintainerclean: distclean
	rm -rf doc web

DIST=tommyds-$(VERSION)

DISTFILES=\
	Makefile \
	README LICENSE AUTHORS INSTALL HISTORY \
	tommy.doxygen tommy.css tommy-header.html tommy-footer.html \
	benchmark.cc \
	benchmark.vcxproj benchmark.sln \
	benchmark.geany \
	check.c

dist:
	mkdir $(DIST)
	cp $(DISTFILES) $(DIST)
	cp $(DEP) $(DIST)
	cp -R doc $(DIST)
	cp -R benchmark $(DIST)/benchmark
	rm -f $(DIST)/benchmark/data/*/*.png
	rm -rf $(DIST)/benchmark/data/test
	rm -f $(DIST)/benchmark/arial.ttf
	rm -f $(DIST).tar.gz
	tar cfzo $(DIST).tar.gz $(DIST)
	rm -f $(DIST).zip
	zip -r $(DIST).zip $(DIST)
	rm -r $(DIST)

=== debian/changelog ===
librtr (0.6.3-1) unstable; urgency=medium

  * Import new upstream release
    - Fixes build issues with big endian architectures
  * Mark librtr-doc as Multi-Arch: foreign
  * Pass --as-needed to the linker to avoid useless dependencies

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sun, 09 Dec 2018 14:04:06 +0100

librtr (0.6.0-1) unstable; urgency=medium

  * Initial release (Closes: #728206)

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 01 Dec 2018 22:43:01 +0100

=== debian/control ===
Source: librtr
Section: libs
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
Build-Depends:
 cmake,
 debhelper (>= 11),
 doxygen,
 libssh-dev,
Standards-Version: 4.2.1
Homepage: https://rtrlib.realmv6.org/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/librtr
Vcs-Git: https://salsa.debian.org/pkg-security-team/librtr.git

Package: librtr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librtr0 (= ${binary:Version}), ${misc:Depends}, libssh-dev
Suggests: librtr-doc
Description: Small extensible RPKI-RTR-Client C library - development files
 RTRlib is an open-source C implementation of the  RPKI/Router Protocol
 client. The library allows one to fetch and store validated prefix origin data
 from a RTR-cache and performs origin verification of prefixes. It supports
 different types of transport sessions (e.g., SSH, unprotected TCP) and is
 easily extendable.
 .
 This package contains development files.

Package: librtr-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Small extensible RPKI-RTR-Client C library - documentation
 RTRlib is an open-source C implementation of the  RPKI/Router Protocol
 client. The library allows one to fetch and store validated prefix origin data
 from a RTR-cache and performs origin verification of prefixes. It supports
 different types of transport sessions (e.g., SSH, unprotected TCP) and is
 easily extendable.
 .
 This package contains the doxygen generated HTML documentation for the
 libraries.

Package: librtr0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Small extensible RPKI-RTR-Client C library
 RTRlib is an open-source C implementation of the  RPKI/Router Protocol
 client. The library allows one to fetch and store validated prefix origin data
 from a RTR-cache and performs origin verification of prefixes. It supports
 different types of transport sessions (e.g., SSH, unprotected TCP) and is
 easily extendable.

Package: rtr-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RPKI-RTR command line tools
 Contains tools provided with RTRlib.
 .
 rtrclient is command line that connects to an RPKI-RTR server and prints
 protocol information and information about the fetched ROAs.
 .
 rpki-rov is a command line tool that connects to an RPKI-RTR server and allows
 validating IP prefixes and origin ASes.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

=== debian/tests/control ===
Tests: tools-usage
Depends: rtr-tools

## librtr 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,22 @@
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=gnu99 -fstack-protector-all")
 if(CMAKE_BUILD_TYPE STREQUAL Debug)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -Wformat-security -Wmissing-prototypes -Wmissing-declarations -Wdeclaration-after-statement -Winit-self -Waggregate-return -Wmissing-format-attribute -Wundef -Wbad-function-cast -Wwrite-strings -Wformat=2")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -Wformat-security -Winit-self -Wundef -Wwrite-strings")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat=2 -Werror=missing-prototypes -Werror=missing-declarations")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-format-attribute -Werror=implicit-function-declaration")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=bad-function-cast -Werror=return-type")
+
     execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
     if(GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
         set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wfree-nonheap-object")
+    endif()
+
+    if(GCC_VERSION VERSION_GREATER 5.1 OR GCC_VERSION VERSION_EQUAL 5.1)
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=incompatible-pointer-types")
+    endif()
+
+    if(GCC_VERSION VERSION_GREATER 8.0 OR GCC_VERSION VERSION_EQUAL 8.0)
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=cast-function-type")
     endif()
 
     set(DOCS_EXCLUDE_PATTERN "")
@@ -19,6 +31,8 @@
 endif(CMAKE_BUILD_TYPE STREQUAL Debug)
 
 include_directories(.)
+
+add_subdirectory(third-party)
 
 find_package(codecov)
 
@@ -33,20 +47,25 @@
     rtrlib/lib/ip.c rtrlib/lib/ipv4.c rtrlib/lib/ipv6.c rtrlib/lib/log.c
     rtrlib/pfx/trie/trie.c rtrlib/pfx/trie/trie-pfx.c rtrlib/transport/transport.c
     rtrlib/transport/tcp/tcp_transport.c rtrlib/rtr/rtr.c rtrlib/rtr/packets.c
-    rtrlib/spki/hashtable/ht-spkitable.c rtrlib/spki/hashtable/tommyds-1.8/tommy.c)
+    rtrlib/spki/hashtable/ht-spkitable.c ${tommyds})
 set(RTRLIB_LINK ${RT_LIB} ${CMAKE_THREAD_LIBS_INIT})
 
-find_package(LibSSH 0.5.0 QUIET)
-if(LIBSSH_FOUND AND NOT NOSSH)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D LIBSSH_VERSION_MAJOR=${LibSSH_VERSION_MAJOR} -D LIBSSH_VERSION_MINOR=${LibSSH_VERSION_MINOR}")
-    set(RTRLIB_HAVE_LIBSSH 1)
-    include_directories(${LIBSSH_INCLUDE_DIRS})
-    set(RTRLIB_SRC ${RTRLIB_SRC} rtrlib/transport/ssh/ssh_transport.c)
-    set(RTRLIB_LINK ${RTRLIB_LINK} ${LIBSSH_LIBRARIES})
-    message(STATUS "libssh found, building librtr with SSH ${LibSSH_VERSION} support")
-else()
-    message(WARNING "libssh >=0.5.0 not found, building librtr without SSH support")
-endif(LIBSSH_FOUND AND NOT NOSSH)
+if (NOT DEFINED RTRLIB_TRANSPORT_SSH OR RTRLIB_TRANSPORT_SSH)
+    find_package(LibSSH 0.5.0 QUIET)
+
+    if(LIBSSH_FOUND)
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D LIBSSH_VERSION_MAJOR=${LibSSH_VERSION_MAJOR} -D LIBSSH_VERSION_MINOR=${LibSSH_VERSION_MINOR}")
+        set(RTRLIB_HAVE_LIBSSH 1)
+        include_directories(${LIBSSH_INCLUDE_DIRS})
+        set(RTRLIB_SRC ${RTRLIB_SRC} rtrlib/transport/ssh/ssh_transport.c)
+        set(RTRLIB_LINK ${RTRLIB_LINK} ${LIBSSH_LIBRARIES})
+        message(STATUS "libssh found, building librtr with SSH ${LibSSH_VERSION} support")
+    elseif(NOT LIBSSH_FOUND AND RTRLIB_TRANSPORT_SSH)
+        message(FATAL_ERROR "libssh >= 0.5.0 not found but ssh support was requested. Omit RTRLIB_TRANSPORT_SSH to build without ssh support.")
+    else()
+        message(WARNING "libssh >= 0.5.0 not found")
+    endif(LIBSSH_FOUND)
+endif(NOT DEFINED RTRLIB_TRANSPORT_SSH OR RTRLIB_TRANSPORT_SSH)
 
 #doxygen target
 find_package(Doxygen)
@@ -92,8 +111,8 @@
 
 #install lib
 set (RTRLIB_VERSION_MAJOR 0)
-set (RTRLIB_VERSION_MINOR 6)
-set (RTRLIB_VERSION_PATCH 3)
+set (RTRLIB_VERSION_MINOR 7)
+set (RTRLIB_VERSION_PATCH 0)
 CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h.cmake ${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h)
 set(LIBRARY_VERSION ${RTRLIB_VERSION_MAJOR}.${RTRLIB_VERSION_MINOR}.${RTRLIB_VERSION_PATCH})
 set(LIBRARY_SOVERSION ${RTRLIB_VERSION_MAJOR})
@@ -118,9 +137,9 @@
 endforeach()
 
 #pkgconfig file
-if(LIBSSH_FOUND)
+if(RTRLIB_TRANSPORT_SSH)
     set (PKG_CONFIG_REQUIRES "libssh >= 0.5.0")
-endif(LIBSSH_FOUND)
+endif(RTRLIB_TRANSPORT_SSH)
 
 # '#include <rtrlib/rtrlib.h>' includes the "rtrlib/"
 set (PKG_CONFIG_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")

=== third-party/tommyds/Makefile ===
#############################################################################
# Tommy Makefile

# Version of TommyDS
VERSION = 2.2

# Build options for the check program
ifdef COVERAGE
CFLAGS = -O0 -g -fprofile-arcs -ftest-coverage
else
CFLAGS = -O3 -march=native -Wall -Wextra -Wshadow -Wuninitialized -Wpadded -Wcast-align -Wcast-qual -g
endif

# Build options for the benchmark
# -std=gnu++0x required by Google btree
BENCHCXXFLAGS = -m32 -O3 -march=native -flto -fpermissive -std=gnu++0x -Wall -g

# Programs
CC ?= gcc
CXX ?= g++
OBJDUMP ?= objdump
UNAME = $(shell uname)

# Linux
ifeq ($(UNAME),Linux)
LIB=-lrt
BENCHLIB=benchmark/lib/judy/libJudyL.a benchmark/lib/judy/libJudyMalloc.a
EXE=
O=.o
endif

# Darwin
ifeq ($(UNAME),Darwin)
LIB=
EXE=
O=.o
endif

# Windows
ifeq ($(UNAME),)
BENCHLIB=benchmark/lib/judy/src/judy.lib
EXE=.exe
O=.obj
endif

#CHECK = ./tommybench -n 1000000 -d tommy-hashlin
CHECK = ./tommycheck

DEP = \
	tommyds/tommyalloc.c \
	tommyds/tommyalloc.h \
	tommyds/tommyarray.c \
	tommyds/tommyarray.h \
	tommyds/tommyarrayof.c \
	tommyds/tommyarrayof.h \
	tommyds/tommyarrayblk.c \
	tommyds/tommyarrayblk.h \
	tommyds/tommyarrayblkof.c \
	tommyds/tommyarrayblkof.h \
	tommyds/tommy.c \
	tommyds/tommy.h \
	tommyds/tommyhash.c \
	tommyds/tommyhashdyn.c \
	tommyds/tommyhashdyn.h \
	tommyds/tommyhash.h \
	tommyds/tommyhashlin.c \
	tommyds/tommyhashlin.h \
	tommyds/tommyhashtbl.c \
	tommyds/tommyhashtbl.h \
	tommyds/tommylist.c \
	tommyds/tommylist.h \
	tommyds/tommytrie.c \
	tommyds/tommytrie.h \
	tommyds/tommytrieinp.c \
	tommyds/tommytrieinp.h \
	tommyds/tommytypes.h \
	tommyds/tommychain.h

DEPTEST = \
	check.c \
	benchmark.cc

all: tommycheck$(EXE)

bench: tommybench$(EXE)

tommy$(O): $(DEP)
	$(CC) $(CFLAGS) -c tommyds/tommy.c -o tommy$(O)
	-$(OBJDUMP) -S tommy$(O) > tommy.s

tommycheck$(EXE): check.c tommy$(O)
	$(CC) $(CFLAGS) check.c tommy$(O) -o tommycheck$(EXE) $(LIB)

tommybench$(EXE): benchmark.cc $(DEP)
	$(CXX) $(BENCHCXXFLAGS) benchmark.cc -o tommybench$(EXE) $(LIB) $(BENCHLIB)

check: tommycheck$(EXE)
	./tommycheck$(EXE)
	echo Check completed with success!

lcov_reset:
	lcov -d . -z
	rm -f ./lcov.info

lcov_capture:
	lcov -d . --capture -o lcov.info

lcov_html:
	rm -rf ./cov
	mkdir cov
	genhtml -o ./cov lcov.info

coverage:
	$(MAKE) COVERAGE=1 tommycheck$(EXE)
	$(MAKE) lcov_reset
	./tommycheck$(EXE)
	$(MAKE) lcov_capture
	$(MAKE) lcov_html

valgrind:
	valgrind \
		--tool=memcheck \
		--track-origins=yes \
		--read-var-info=yes \
		-v $(CHECK) \
		2> valgrind.log
		tail valgrind.log

callgrind:
	valgrind \
		--tool=callgrind \
		--dump-instr=yes \
		--trace-jump=yes \
		-v $(CHECK) \
		2> callgrind.log
		tail callgrind.log

cachegrind:
	valgrind \
		--tool=cachegrind \
		-v $(CHECK) \
		2> cachegrind.log
		tail cachegrind.log

phony:

graph: phony
	cd benchmark && sh gr_all.sh

doc: phony tommy.doxygen tommy.css $(DEP)
	rm -rf doc
	mkdir doc
	cp -a benchmark/data/def doc/def
	cp -a benchmark/data/other doc/other
	cp -a benchmark/data/core_i5_650_3G2_linux doc/core_i5_650_3G2_linux
	rm -f doc/*/*.lst
	rm -f doc/*/*.gnu
	doxygen tommy.doxygen
	rm -f doc/doxygen.png
	rm -f doc/tab_*.png

web: phony tommyweb.doxygen tommy.css $(DEP)
	rm -rf web
	mkdir web
	cp -a benchmark/data/def web/def
	cp -a benchmark/data/other web/other
	cp -a benchmark/data/core_i5_650_3G2_linux web/core_i5_650_3G2_linux
	rm -f web/*/*.lst
	rm -f web/*/*.gnu
	doxygen tommyweb.doxygen
	rm -f web/doxygen.png
	rm -f web/tab_*.png

clean:
	rm -f *.log *.s *.lst *.o
	rm -f *.ncb *.suo *.obj
	rm -f *.gcno *.gcda lcov.info
	rm -rf Debug Release x64
	rm -f callgrind.out.*
	rm -f cachegrind.out.*

distclean: clean
	rm -f tommybench$(EXE) tommycheck$(EXE)

maintainerclean: distclean
	rm -rf doc web

DIST=tommyds-$(VERSION)

DISTFILES=\
	Makefile \
	README LICENSE AUTHORS INSTALL HISTORY \
	tommy.doxygen tommy.css tommy-header.html tommy-footer.html \
	benchmark.vcxproj benchmark.sln \
	benchmark.geany \
	benchmark.cc \
	check.c

dist:
	mkdir $(DIST)
	mkdir $(DIST)/tommyds
	cp $(DISTFILES) $(DIST)
	cp $(DEP) $(DIST)/tommyds
	cp $(DEPTEST) $(DIST)
	cp -R doc $(DIST)
	cp -R benchmark $(DIST)/benchmark
	rm -f $(DIST)/benchmark/data/*/*.png
	rm -rf $(DIST)/benchmark/data/test
	rm -f $(DIST)/benchmark/arial.ttf
	rm -f $(DIST).tar.gz
	tar cfzo $(DIST).tar.gz $(DIST)
	rm -f $(DIST).zip
	zip -r $(DIST).zip $(DIST)
	rm -r $(DIST)

distcheck: dist
	tar zxvf $(DIST).tar.gz
	cd $(DIST) && make check
	rm -rf $(DIST)

=== debian/changelog ===
librtr (0.7.0-1) unstable; urgency=medium

  [ Samuel Henrique ]
  * Team upload.
  * Add salsa-ci.yml.

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Francisco Vilmar Cardoso Ruviaro ]
  * New upstream version 0.7.0.
  * Bump DH level to 13.
  * Bump Standards-Version to 4.5.1.
  * debian/control:
      - Add 'Rules-Requires-Root: no'.
      - Add pkg-config as build dependency.
  * debian/copyright: update upstream and packaging copyright.
  * debian/p/Use-FindPkgConfig-to-search-for-libssh-availability.patch: add.
    Thanks to Marcel Röthke <marcel.roethke@haw-hamburg.de>. (Closes: #975174)
  * debian/rules: drop DEB_LDFLAGS_MAINT_APPEND -Wl,--as-needed,
    because this is default behavior in bullseye toolchain.

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Sat, 16 Jan 2021 16:06:05 +0000

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,12 @@
 Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
 Build-Depends:
  cmake,
- debhelper (>= 11),
+ debhelper-compat (= 13),
  doxygen,
  libssh-dev,
-Standards-Version: 4.2.1
+ pkg-config
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
 Homepage: https://rtrlib.realmv6.org/
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/librtr
 Vcs-Git: https://salsa.debian.org/pkg-security-team/librtr.git

## librtr 0.8.0

=== debian/changelog ===
librtr (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0.
  * Update Standards-Version, no changes necessary.
  * Refresh patches, drop those merged upstream.
  * Add patch to disable full paths in Doxygen documentation.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 11 Sep 2021 16:43:15 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  doxygen,
  libssh-dev,
  pkg-config
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://rtrlib.realmv6.org/
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/librtr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%librtr-$1.tar.gz%" \
   https://github.com/rtrlib/rtrlib/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian
